routes/web.php
<?php

use App\Http\Controllers\BackendController;
use App\Http\Controllers\BookingController;
use App\Http\Controllers\BrandController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ColorController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\CourseController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\DistrictController;
use App\Http\Controllers\frontend\FrontendCategoryController;
use App\Http\Controllers\frontend\FrontendProductController;
use App\Http\Controllers\FrontendController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\PublicController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\SizeController;
use App\Http\Controllers\TagController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\SliderController;
use App\Http\Controllers\CustomerController;
use App\Http\Controllers\FaqController;
use Illuminate\Support\Facades\Route;
use Spatie\FlareClient\Api;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/



// Route::get('/dashboard', function () {
//     return view('dashboard');
// })->middleware(['auth'])->name('dashboard');

require __DIR__.'/auth.php';
Route::get('Front/index', [PublicController::class, 'index'])->name('homepage');
Route::get('Front/cart', [PublicController::class, 'cart'])->name('Cart');
Route::get('Front/checkout', [PublicController::class, 'checkout'])->name('Check');
Route::get('Front/order', [PublicController::class, 'order'])->name('order');
Route::get('Front/shop', [PublicController::class, 'shop'])->name('Shop');
Route::get('Front/checkout', [PublicController::class, 'product'])->name('Product');
Route::get('/about', [PublicController::class, 'about'])->name('About');
// Route::get('Front/index', [PublicController::class, 'index']);
// Route::get('Front/cart', [PublicController::class, 'cart'])->name('Cart');
// Route::get('Front/checkout', [PublicController::class, 'checkout'])->name('Check');
// Route::get('Front/order', [PublicController::class, 'order'])->name('order');
// Route::get('Front/shop', [PublicController::class, 'shop'])->name('Shop');
// Route::get('Front/checkout', [PublicController::class, 'product'])->name('Product');
// Route::get('/about', [PublicController::class, 'about'])->name('About');

// Route::get('/sign-in', [AuthController::class, 'login'])->name('sign_in');
// Route::get('/sign-up', [AuthController::class, 'registration'])->name('sign_up');
//route group*****************************************************
// Route::controller(ProductsController::class)->prefix('products')->group(function(){
//     Route::get('/','index')->name('pro_index');
//     Route::get('/create','create')->name('pro_create');
//     Route::get('/show','show')->name('pro_show');
// });
//middleware******************************************************
//Route::get('/admin',[DashboardController::class,'dashboard' ])->middleware('admin');
// Route::middleware('admin')->group(function(){
//     Route::get('/admin',[DashboardController::class,'dashboard' ]);
//     Route::controller(ProductsController::class)
//     ->name('products.')
//     ->prefix('products')
//     ->group(function(){
//         Route::get('/','index')->name('index');
//         // Route::get('/create','create')->name('create');
//         Route::get('/show','show')->name('show');
//     });
//     // Route::fallback(function () {
//     //     echo "Sorry";
//     // });
// });
//basic routing***************************************************
// Route::get('/', function () {
//     return view('index');
// });
// Route::get('/index', function () {
//     return "hello world";
// });
//view route*****************************
// Route::view('/', 'index');
//fallback route*************************
// Route::fallback(function () {
//     echo "Sorry";
// });

//redirect*******************************
//Route::redirect('/here', '/ounnokisu');
//require parameter*********************************************************
// Route::get('/products/{id?}', [ProductsController::class, 'show']);
// Route::get('/products/create', [ProductsController::class, 'create']);
Route::get('/', [FrontendController::class, 'index'])->name('Homepage');
Route::get('/category', [FrontendController::class,'category']);
Route::get('/components/frontend/layout/master', [FrontendController::class, 'master'])->name('frontend.master');
Route::get('/category/{category}/products', [FrontendController::class, 'categoryWiseProducts'])->name('categories.products');
Route::get('/products/{product}', [FrontendController::class, 'productDetails'])->name('frontend.product.detail');
Route::post('/products/{product}/comments', [CommentController::class, 'store'])->name('products.comments.store');
Route::get('/components/backend/layout/master', [BackendController::class, 'master'])->name('backend.master');
Route::get('/backend/index', [BackendController::class, 'index']);

// Route::get('/products/{product}/booking', [BookingController::class, 'booking'])->name('booking');

// Route::get('/products/{product}/checkout-address', [BookingController::class, 'checkoutAddress'])->name('checkout.address');
// Route::get('/products/{product}/checkout-payment', [BookingController::class, 'checkoutPayment'])->name('checkout.payment');
// Route::get('/products/{product}/checkout-review', [BookingController::class, 'checkoutReview'])->name('checkout.review');



Route::get('/faqs', [FaqController::class,'frontendshow'])->name('faqs.frontend');

Route::middleware('auth','isAdmin')->prefix('backend')->group(function () {
    Route::get('/', [BackendController::class, 'index'])->name('backend.index');
    // Route::get('/product', [ProductController::class, 'index'])->name('product.index');
    // Route::get('/product/create', [ProductController::class, 'create'])->name('product.create');
    
    // Route::get('/colors', [ColorController::class, 'index'])->name('colors.index');
    // Route::get('/colors/create', [ColorController::class, 'create'])->name('colors.create');
    // Route::post('/colors', [ColorController::class, 'store'])->name('colors.store');
    // Route::get('/colors/{color}', [ColorController::class, 'show'])->name('colors.show');
    // Route::get('/colors/{color}/edit', [ColorController::class, 'edit'])->name('colors.edit');
    // Route::patch('/colors/{color}/edit', [ColorController::class, 'update'])->name('colors.update');
    // Route::delete('/colors/{color}', [ColorController::class, 'destroy'])->name('colors.destroy');
    Route::get('/products/trash', [ProductController::class, 'trash'])->name('products.trash');
    Route::patch('/products/trash/{id}', [ProductController::class, 'restore'])->name('products.restore');
    Route::delete('/products/trash/{id}', [ProductController::class, 'delete'])->name('products.delete');
   
    Route::get('/products/list/{category}', [CategoryController::class, 'productlist'])->name('products.list');
    Route::get('/categories/trash', [CategoryController::class, 'trash'])->name('categories.trash');
    Route::patch('/categories/trash/{id}', [CategoryController::class, 'restore'])->name('categories.restore');
    Route::delete('/categories/trash/{id}', [CategoryController::class, 'delete'])->name('categories.delete');
    Route::get('categories/download-pdf', [CategoryController::class, 'downloadPdf'])->name('categories.download_pdf');
    Route::get('categories/download-excel', [CategoryController::class, 'downloadExcel'])->name('categories.download_excel');
    
    Route::get('/courses/trash', [CourseController::class, 'trash'])->name('courses.trash');
    Route::get('courses/download-pdf', [CourseController::class, 'downloadPdf'])->name('courses.download_pdf');
    Route::get('courses/download-excel', [CourseController::class, 'downloadExcel'])->name('courses.download_excel');
    Route::resource('courses', CourseController::class);
    Route::resource('colors', ColorController::class);
    Route::resource('categories', CategoryController::class);
    Route::resource('sizes', SizeController::class);
    Route::resource('tags', TagController::class);
    Route::resource('districts', DistrictController::class); 
    Route::resource('brands', BrandController::class);
    Route::resource('products', ProductController::class);
    Route::resource('users', UserController::class);
    Route::resource('roles', RoleController::class);
    Route::resource('faqs', FaqController::class);
    
    
     // ===============Slider==============

     Route::get('/sliders/trash', [SliderController::class, 'trash'])->name('sliders.trash');     
     Route::patch('/sliders/trash/{id}', [SliderController::class, 'restore'])->name('sliders.restore');
     Route::delete('/sliders/trash/{id}', [SliderController::class, 'delete'])->name('sliders.delete');

     Route::resource('sliders', SliderController::class);


    
});

Route::prefix('frontend')->group(function () {
    
});



Route::middleware('auth','isUser')->group(function () {
    Route::get('booking-list/{user}',  [CustomerController::class, 'booking'])->name('customer.bookingList');
    Route::get('wishlist/{user}',  [CustomerController::class, 'wishlist'])->name('customer.wishlist');
    Route::get('/my-account/{user}',  [CustomerController::class, 'account'])->name('customer.account');
});


Route::middleware(['auth'])->group(function () {
    // Route::get('account/{user}',  [ProfileController::class, 'account'])->name('customer.profile');

app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Product extends Model
{
    use HasFactory,SoftDeletes;
    protected $fillable=['title','image','rent','description','address','discount','is_active'];
    public function category(){
        return $this->belongsTo(Category::class);
    }
    public function comments(){
        return $this->hasMany(Comment::class)->orderBy('created_at', 'desc');
    }
    public function categories()
    {
        return $this->belongsToMany(Category::class);
    }


}

app/Http/Controllers/BackendController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class BackendController extends Controller
{
    public function master(){
        return view('components.backend.layout.master');
    }
    public function index(){
        return view('backend.index');
    }
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\ProductRequest;
use App\Models\Category;
use App\Models\Product;
use Illuminate\Database\QueryException;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Redirect;
use Illuminate\Support\Facades\Session;
use Image;
class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $this->authorize('product-list');
        $products = Product::latest()->paginate(20);
 
        return view('backend.products.index',compact('products'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        
        $categories = Category::pluck('categories_name', 'id')->toArray();
        return view('backend.products.create',compact('categories'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ProductRequest $request)
    {
    
        try {
       
            // Product::create([
            //     'title' => $request->title,
            //     'price' => $request->price,
            //     'discount' => $request->discount,
            //      'category_id' => $request->category,
            //      'description' => $request->description,
            //      'is_active' => $request->is_active ? true : false,
            //     //  'image' => $this->uploadImage($request->file('image'))
            // ]);
            $requestData = $request->all();
            $requestData['image'] = $this->uploadImage($request->file('image'));
            $product = Product::create($requestData);

            $product->categories()->attach($requestData['category_ids']);
             
             Session::flash('message', 'Created Successfully!');
             return redirect()->route('products.index');
         } catch (QueryException $e) {
 
             return Redirect::back()->withInput()->withErrors($e->getMessage());
         }
        return view('backend.products.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Product $product)
    {
        return view('backend.products.show', compact('product'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $product)
    {
        $categories = Category::pluck('categories_name', 'id')->toArray();
        $selectedCategories = $product->categories->pluck('id')->toArray();
        // dd($product);
        return view('backend.products.edit', compact('categories', 'product', 'selectedCategories'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(ProductRequest $request, Product $product)
    {
        try {
            $requestData = $request->all();
            $requestData['image'] = $request->file('image') ? $this->uploadImage($request->file('image')) : $product->image;
            $requestData['is_active'] = $request->is_active ?? 0;
            $product->update($requestData);
            $product->categories()->sync($requestData['category_ids']);
            return redirect()->route('products.index')->withMessage('Successfully Updated');
        } catch (QueryException $e) {
            return redirect()->back()->withInput()->withErrors($e->getMessage());
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Product $product)
    {
        $product->categories()->detach();
        $product->delete();
        return redirect()->route('products.index')->withMessage('Successfully Deleted');
    }


    public function uploadImage($file = null)
    {
        if (is_null($file)) return $file;

        $fileName = date('dmY') . time() . '.' . $file->getClientOriginalExtension();
        Image::make($file)
            ->resize(400, 500)
            ->save(storage_path('app/public/products/' . $fileName));
        return $fileName;
    }

    
    public function trash()
    {
    
        $products = Product::onlyTrashed()->paginate(2);
        return view('backend.products.trash', compact('products'));
    }
    public function restore($id)
    {
        try {
            $product = Product::onlyTrashed()->whereId($id)->firstOrFail();
            $product->restore();
            return redirect()->back()->withMessage('Successfully Restored !');
        } catch (QueryException $e) {
            Log::error($e->getMessage());
            return redirect()->back()->withErrors($e->getMessage());
        }
    }

    public function delete($id)
    {
        try {
            $product = Product::onlyTrashed()->whereId($id)->firstOrFail();
            $product->forceDelete();
            return redirect()->route('products.index')->withMessage('Successfully Deleted');
        } catch (QueryException $e) {
            Log::error($e->getMessage());
            return redirect()->back()->withErrors($e->getMessage());
        }
    }




}

resources/views/backend/products/create.blade.php
<x-backend.layout.master>
    <x-slot:title>
        Create products
    </x-slot:title>

    <div class="card mb-4">
                <div class="card-header">
                    <i class="fas fa-table"></i>
                    Product Create 
                    <x-backend.utilities.link-index href="{{route('products.index')}}" text="Products List "/>
                    <!-- <a href="{{ route('roles.index') }}" class="btn btn-sm btn-primary">List</a> -->
                </div>
                <div class="card-body">
                    @if ($errors->any())
                        <x-backend.alerts.errors />
                    @endif

                                <form action="{{ route('products.store') }}" method="post" enctype="multipart/form-data">
                                  
                                  @csrf
                                    <x-backend.forms.input name="title" type="text" :value="old('title')" />


                                   
                                        <label for="">Category Name</label>
                                        @foreach ($categories as $key=>$value)
                                        <div class="mb-3 form-check">
                                            <input name="category_ids[]" class="form-check-input" type="checkbox" value="{{ $key }}" id="{{ $key  }}">
                                            <label class="form-check-label" for="{{ $key }}">
                                                {{ $value }}
                                            </label>
                                        </div>
                                        @endforeach
                           

                                    <br>
                               
                                    <x-backend.forms.input name="rent" type="number" :value="old('rent')" />

                                    <x-backend.forms.input name="image" type="file" />
                                    <x-backend.forms.input name="discount" type="number" :value="old('discount')" />

                                    <x-backend.forms.textarea name="address" :value="old('address')" />

                                    <x-backend.forms.textarea name="description" :value="old('description')"/>
                                           
                                    <div class="mb-3 form-check">
                                        <input type="checkbox" value="1" name="is_active" class="form-check-input"
                                            id="isactiveinput">
                                        <label class="form-check-label" for="isactiveinput">Is Active</label>
                                    </div>
                                    <x-backend.forms.submit />
                                   
                                </form>
                </div>
    </div>

</x-backend.layout.master>

resources/views/backend/products/edit.blade.php
<x-backend.layout.master>
    <x-slot:title>
        Edit Product
    </x-slot:title>

    <div class="card mb-4">
                <div class="card-header">
                    <i class="fas fa-table"></i>
                    Edit Product
                    <x-backend.utilities.link-index href="{{route('products.index')}}" text="Products List "/>
                </div>
                <div class="card-body">
                    @if ($errors->any())
                        <x-backend.alerts.errors />
                    @endif
                                <form action="{{ route('products.update', ['product' => $product->id]) }}" method="post" enctype="multipart/form-data">
                                  
                                  @csrf
                                  @method('patch')
                                    <x-backend.forms.input name="title" type="text" :value="old('title', $product->title)" />
                                    
                                        <label for="">Category Name</label>
                                      
                                        @foreach ($categories as $key=>$value)
                                        <div class="mb-3 form-check">
                                            <input name="category_ids[]" class="form-check-input" type="checkbox" value="{{ $key }}" id="{{ $key  }}" {{ in_array($key, $selectedCategories) ? 'checked' : '' }}>
                                            <label class="form-check-label" for="{{ $key }}">
                                                {{ $value }}
                                            </label>
                                        </div>
                                        @endforeach

                                        @error('category')
                                            <div class="form-text text-danger">{{ $message }}</div>
                                        @enderror
                                    
                               
                                    <x-backend.forms.input name="rent" type="number" :value="old('rent', $product->rent)" />

                                    <img src="{{ asset('storage/products/'.$product->image) }}" alt="{{$product->title}} Image" height="200">
                                    <x-backend.forms.input name="image" type="file" />
                                    <x-backend.forms.input name="discount" type="number" :value="old('discount', $product->discount)" />

                                    <x-backend.forms.textarea name="address" :value="old('address', $product->address)"/>

                                    <x-backend.forms.textarea name="description" :value="old('description', $product->description)"/>

                                    <label>Status</label>
                                    <div class="mb-3 form-check">
                                        <input name="is_active" class="form-check-input" type="checkbox" value="1" id="isActiveInput" {{ $product->is_active ? 'checked' : '' }}>
                                        <label class="form-check-label" for="isActiveInput">
                                            Active
                                        </label>
                                    </div>
                                    <x-backend.forms.submit text="Update"/>
                                   
                                </form>
                </div>
    </div>

</x-backend.layout.master>

resources/views/backend/products/index.blade.php
<x-backend.layout.master>
    <x-slot:title>
        Products
        </x-slot:>

        <div class="card mb-4">
        <div class="card-header">
        <i class="fas fa-table me-1"></i>
        Products List
            <x-backend.utilities.link-create href="{{route('products.create')}}" text="Add Product"/>
            <x-backend.utilities.link-create href="{{route('products.trash')}}" text="Trash"/>
        </div>
        <div class="card-body">
<!-- //message  -->
    <x-backend.alerts.message type="success" :message="session('message')"/>

        <table class="table table-striped table-hover table-bordered">
                        <thead>
                            <tr>
                                <th class="col-md-0.5">SL#</th>
                                <th class="col-md-1">Title</th>
                                <th class="col-md-1">Category</th>
                                <th class="col-md-1">Rent</th>
                                <th class="col-md-0.5">Discount</th>
                                <th class="col-md-1">Image</th>
                                <th class="col-md-0.5">Is_Active</th>
                                <th class="col-md-2.5">Description</th> 
                                <th class="col-md-2.5">Address</th> 
                                <th class="col-md-1">Action</th>
                            </tr>
                        </thead>

                        <tbody>
                            
                            @foreach ($products as $product)

                                <tr>
                                    <td>{{ $loop->iteration }}</td>
                                    <td>{{ $product->title }}</td>
                                    <td> 
                                        <ul>
                                        @foreach ($product->categories as $category)
                                            <li>{{ $category->categories_name }}</li>
                                        @endforeach
                                    </ul>
                                </td>
                                    <td>{{ $product->rent }}</td>
                                    <td>{{ $product->discount }}</td>

                                    <td><img src="{{ asset('storage/products/'.$product->image) }}" alt="{{$product->title}} Image" height="50"></td>
                                    <td>{{ $product->is_active? 'Active' : 'In Active'}}</td>
                                    <td>{{ $product->description }}</td>
                                    <td>{{ $product->address }}</td>
                                    <td style="text-align:center; padding-left:0; padding-right:0;">
                                        <x-backend.utilities.link-show href="{{ route('products.show', ['product'=>$product->id]) }}" text="Show" />
                                        <x-backend.utilities.link-edit href="{{ route('products.edit', ['product'=>$product->id]) }}" text="Edit" />
                                        <x-backend.forms.delete action="{{ route('products.destroy', ['product' => $product->id]) }}"/>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                        {{ $products->links() }}
                </div>
            </div>

            @push('css')
                <style>
                    /* body{
                        background-color: blue;
                    } */
                </style>
            @endpush
            @push('js')
                <script src="https://cdn.jsdelivr.net/npm/simple-datatables@latest" crossorigin="anonymous"></script>
                <script src="{{ asset('ui/backend/js/datatables-simple-demo.js') }}"></script>
            @endpush
</x-backend.layout.master>

resources/views/backend/products/list.blade.php
<x-backend.layout.master>
    <x-slot:title>
        Products
        </x-slot:>
        <x-slot:pagetitle>
            Products
            </x-slot:>
            <div class="card mb-4">
                <div class="card-header">
                    <i class="fas fa-table me-1"></i>
                    Product List
                    <a href="{{ route('products.create') }}" class="btn btn-sm btn-primary">Add New</a>
                </div>
                <div class="card-body">
                    <table id="datatablesSimple">
                        <thead>
                            <tr>
                                <th>#</th>
                                <th>Title</th>
                                <th>Category</th>
                                <th>Price</th>
                                <th>Discount</th>
                                <th>Image</th>
                                <th>is_active</th>
                                <th>Description</th>
                                <th>Action</th>

                            </tr>
                        </thead>

                        <tbody>
                            @foreach ($category->products as $product)
                                <tr>
                                    <td>{{ $loop->iteration }}</td>
                                    <td>{{ $product->title }}</td>
                                    <td>{{ $category->categories_name}}</td>
                                    <td>{{ $product->price}}</td>
                                    <td>{{ $product->discount}}</td>
                                    <td></td>
                                    <td>{{ $product->is_active}}</td>
                                    <td>{{ $product->description}}</td>
                                  
                                  
                                    <td>
                                        <x-backend.utilities.link-show
                                            href="{{ route('products.show', ['product' => $product->id]) }}"
                                            icon="fas fa-eye" />
                                        <x-backend.utilities.link-edit
                                            href="{{ route('products.edit', ['product' => $product->id]) }}"
                                            icon="fas fa-edit" />

                                        <form action="{{ route('products.destroy', ['product' => $product->id]) }}"
                                            method="post" style="display:inline">
                                            @csrf
                                            @method('delete')
                                            <x-backend.forms.button text='Delete' color='danger' icon='fas fa-trash'
                                                onclick="return confirm('Are you sure want to delete?')" />
                                        </form>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>

            @push('css')
                <style>
                    /* body{
                        background-color: blue;
                    } */
                </style>
            @endpush
            @push('js')
                <script src="https://cdn.jsdelivr.net/npm/simple-datatables@latest" crossorigin="anonymous"></script>
                <script src="{{ asset('ui/backend/js/datatables-simple-demo.js') }}"></script>
            @endpush
</x-backend.layout.master>